﻿-- Upgrade script to 3.3 from 3.2.

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_CL_MAP_ITEM') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE CODELIST_MAP ADD CONSTRAINT FK_CL_MAP_ITEM FOREIGN KEY(CLM_ID) REFERENCES ITEM(ITEM_ID) ON DELETE CASCADE
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_CL_MAP_SS') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE CODELIST_MAP ADD CONSTRAINT FK_CL_MAP_SS FOREIGN KEY(SS_ID) REFERENCES STRUCTURE_SET(SS_ID) ON DELETE CASCADE
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_CL_MAP_SOURCE') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE CODELIST_MAP ADD CONSTRAINT FK_CL_MAP_SOURCE FOREIGN KEY(SOURCE_CL_ID) REFERENCES CODELIST(CL_ID)
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_CL_MAP_TARGET') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE CODELIST_MAP ADD CONSTRAINT FK_CL_MAP_TARGET FOREIGN KEY(TARGET_CL_ID) REFERENCES CODELIST(CL_ID)
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_CD_MAP_CLM') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE CODE_MAP ADD CONSTRAINT FK_CD_MAP_CLM FOREIGN KEY(CLM_ID) REFERENCES CODELIST_MAP(CLM_ID) ON DELETE CASCADE
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_CD_MAP_SOURCE') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE CODE_MAP ADD CONSTRAINT FK_CD_MAP_SOURCE FOREIGN KEY(SOURCE_LCD_ID) REFERENCES DSD_CODE(LCD_ID)
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_CD_MAP_TARGET') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE CODE_MAP ADD CONSTRAINT FK_CD_MAP_TARGET FOREIGN KEY(TARGET_LCD_ID) REFERENCES DSD_CODE(LCD_ID)
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_STR_MAP_ITEM') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE STRUCTURE_MAP ADD CONSTRAINT FK_STR_MAP_ITEM FOREIGN KEY(SM_ID) REFERENCES ITEM(ITEM_ID) ON DELETE CASCADE
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_STR_MAP_SS') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE STRUCTURE_MAP ADD CONSTRAINT FK_STR_MAP_SS FOREIGN KEY(SS_ID) REFERENCES STRUCTURE_SET(SS_ID) ON DELETE CASCADE
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_STR_MAP_SOURCE') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE STRUCTURE_MAP ADD CONSTRAINT FK_STR_MAP_SOURCE FOREIGN KEY(SOURCE_STR_ID) REFERENCES ARTEFACT(ART_ID)
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_STR_MAP_TARGET') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE STRUCTURE_MAP ADD CONSTRAINT FK_STR_MAP_TARGET FOREIGN KEY(TARGET_STR_ID) REFERENCES ARTEFACT(ART_ID)
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_C_MAP_SM') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE COMPONENT_MAP ADD CONSTRAINT FK_C_MAP_SM FOREIGN KEY(SM_ID) REFERENCES STRUCTURE_MAP(SM_ID) ON DELETE CASCADE
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_C_MAP_SOURCE') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE COMPONENT_MAP ADD CONSTRAINT FK_C_MAP_SOURCE FOREIGN KEY(SOURCE_COMP_ID) REFERENCES COMPONENT(COMP_ID)
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_C_MAP_TARGET') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE COMPONENT_MAP ADD CONSTRAINT FK_C_MAP_TARGET FOREIGN KEY(TARGET_COMP_ID) REFERENCES COMPONENT(COMP_ID)
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_ANN_TEXT') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE ANNOTATION_TEXT ADD CONSTRAINT FK_ANN_TEXT FOREIGN KEY(ANN_ID) REFERENCES ANNOTATION(ANN_ID) ON DELETE CASCADE
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_ART_ANN_ANN') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE ARTEFACT_ANNOTATION ADD CONSTRAINT FK_ART_ANN_ANN FOREIGN KEY(ANN_ID) REFERENCES ANNOTATION(ANN_ID) ON DELETE CASCADE
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_ART_ANN_ART') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE ARTEFACT_ANNOTATION ADD CONSTRAINT FK_ART_ANN_ART FOREIGN KEY(ART_ID) REFERENCES ARTEFACT(ART_ID) ON DELETE CASCADE
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_ITEM_ANN_ANN') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE ITEM_ANNOTATION ADD CONSTRAINT FK_ITEM_ANN_ANN FOREIGN KEY(ANN_ID) REFERENCES ANNOTATION(ANN_ID) ON DELETE CASCADE
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_ITEM_ANN_ITEM') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE ITEM_ANNOTATION ADD CONSTRAINT FK_ITEM_ANN_ITEM FOREIGN KEY(ITEM_ID) REFERENCES ITEM(ITEM_ID) ON DELETE CASCADE
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_COMP_ANN_ANN') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE COMPONENT_ANNOTATION ADD CONSTRAINT FK_COMP_ANN_ANN FOREIGN KEY(ANN_ID) REFERENCES ANNOTATION(ANN_ID) ON DELETE CASCADE
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_COMP_ANN_COMP') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE COMPONENT_ANNOTATION ADD CONSTRAINT FK_COMP_ANN_COMP FOREIGN KEY(COMP_ID) REFERENCES COMPONENT(COMP_ID) ON DELETE CASCADE
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_GR_ANN_ANN') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE GROUP_ANNOTATION ADD CONSTRAINT FK_GR_ANN_ANN FOREIGN KEY(ANN_ID) REFERENCES ANNOTATION(ANN_ID) ON DELETE CASCADE
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_GR_ANN_GR') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE GROUP_ANNOTATION ADD CONSTRAINT FK_GR_ANN_GR FOREIGN KEY(GR_ID) REFERENCES DSD_GROUP(GR_ID) ON DELETE CASCADE
;


CREATE TABLE CONTENT_CONSTRAINT
(
       CONT_CONS_ID bigint NOT NULL,
       ACTUAL_DATA BIT  NOT NULL DEFAULT 1 ,
       PERIODICITY varchar(50) NULL,
       OFFSET varchar(50) NULL,
       TOLERANCE varchar(50) NULL
)
;

CREATE TABLE CONTENT_CONSTRAINT_ATTACHMENT
(
       CONT_CONS_ID bigint NOT NULL,
       ART_ID bigint NOT NULL
)
;

CREATE TABLE CUBE_REGION
(
       CUBE_REGION_ID bigint identity(1,1) NOT NULL,
       CONT_CONS_ID bigint NOT NULL,
       INCLUDE BIT NOT NULL DEFAULT 1 
)
;

CREATE TABLE CUBE_REGION_KEY_VALUE
(
	CUBE_REGION_KEY_VALUE_ID bigint identity(1,1) NOT NULL,
	CUBE_REGION_ID bigint NOT NULL,
	MEMBER_ID VARCHAR(50) NOT NULL,
	COMPONENT_TYPE VARCHAR(50) NOT NULL,
	INCLUDE BIT DEFAULT 1 NOT NULL
)
;
CREATE TABLE CUBE_REGION_VALUE
(
	CUBE_REGION_KEY_VALUE_ID bigint NOT NULL,
	MEMBER_VALUE VARCHAR(50) NOT NULL,
	INCLUDE BIT DEFAULT 1 NOT NULL
)
;

ALTER TABLE CUBE_REGION ADD CONSTRAINT PK_CUBE_REGION
    PRIMARY KEY(CUBE_REGION_ID)
;

ALTER TABLE CUBE_REGION_VALUE ADD CONSTRAINT PK_CUBE_REGION_VALUE
    PRIMARY KEY(CUBE_REGION_KEY_VALUE_ID, MEMBER_VALUE)
;

ALTER TABLE CUBE_REGION_KEY_VALUE ADD CONSTRAINT PK_CUBE_REGION_KEY_VALUE
    PRIMARY KEY(CUBE_REGION_KEY_VALUE_ID)
;

ALTER TABLE CONTENT_CONSTRAINT_ATTACHMENT ADD CONSTRAINT PK_CONTENT_CONSTRAINT_ATT
    PRIMARY KEY(CONT_CONS_ID, ART_ID)
;

ALTER TABLE CONTENT_CONSTRAINT ADD CONSTRAINT PK_CONTENT_CONSTRAINT
    PRIMARY KEY(CONT_CONS_ID)
;

ALTER TABLE CONTENT_CONSTRAINT ADD CONSTRAINT FK_CONT_CONS_ART FOREIGN KEY(CONT_CONS_ID) REFERENCES ARTEFACT(ART_ID) ON DELETE CASCADE
;
ALTER TABLE CONTENT_CONSTRAINT_ATTACHMENT ADD CONSTRAINT FK_CONT_CONS_ATT_CONT_CONS FOREIGN KEY(CONT_CONS_ID) REFERENCES CONTENT_CONSTRAINT(CONT_CONS_ID) ON DELETE CASCADE
;
ALTER TABLE CONTENT_CONSTRAINT_ATTACHMENT ADD CONSTRAINT FK_CONT_CONS_ATT_ART FOREIGN KEY(ART_ID) REFERENCES ARTEFACT(ART_ID)
;
ALTER TABLE CUBE_REGION ADD CONSTRAINT FK_CUBE_REGION_CONT_CONS FOREIGN KEY(CONT_CONS_ID) REFERENCES CONTENT_CONSTRAINT(CONT_CONS_ID) ON DELETE CASCADE
;
ALTER TABLE CUBE_REGION_KEY_VALUE ADD CONSTRAINT FK_CUBE_REGION_KEY_CR FOREIGN KEY(CUBE_REGION_ID) REFERENCES CUBE_REGION(CUBE_REGION_ID) ON DELETE CASCADE
;
ALTER TABLE CUBE_REGION_VALUE ADD CONSTRAINT FK_CUBE_REGION_VALUE_CRKV FOREIGN KEY(CUBE_REGION_KEY_VALUE_ID) REFERENCES CUBE_REGION_KEY_VALUE(CUBE_REGION_KEY_VALUE_ID) ON DELETE CASCADE
;

GO
;
CREATE PROCEDURE INSERT_CONTENT_CONSTRAINT
       @p_id varchar(50),
       @p_version varchar(50),
       @p_agency varchar(50),
       @p_valid_from datetime = NULL,
       @p_valid_to datetime = NULL,
       @p_is_final bigint = NULL,
       @p_uri nvarchar(50),
       @p_last_modified  datetime = NULL,
       @p_actual_data bigint = 1,
       @p_periodicity varchar(50) = NULL,
       @p_offset varchar(50) = NULL,
       @p_tolerance varchar(50) = NULL,
       @p_pk bigint OUT
AS
BEGIN
	SET NOCOUNT ON;
	SET XACT_ABORT ON;
	DECLARE @starttrancount int;
	SET @starttrancount = @@TRANCOUNT;
	BEGIN TRY
		IF @starttrancount = 0 
			BEGIN TRANSACTION
	
	   exec INSERT_ARTEFACT @p_id = @p_id,@p_version = @p_version,@p_agency = @p_agency,@p_valid_from = @p_valid_from,@p_valid_to = @p_valid_to,@p_is_final = @p_is_final,@p_uri = @p_uri, @p_last_modified = @p_last_modified, @p_pk = @p_pk OUTPUT;

       INSERT INTO CONTENT_CONSTRAINT
           (CONT_CONS_ID, ACTUAL_DATA, PERIODICITY, OFFSET, TOLERANCE)
     VALUES
           (@p_pk, @p_actual_data, @p_periodicity, @p_offset, @p_tolerance);
IF @starttrancount = 0 
	        COMMIT TRANSACTION

	END TRY
	BEGIN CATCH
		DECLARE @ErrorMessage NVARCHAR(4000);
		DECLARE @ErrorSeverity INT;
		DECLARE @ErrorState INT;

		SELECT 
			@ErrorMessage = ERROR_MESSAGE(),
			@ErrorSeverity = ERROR_SEVERITY(),
			@ErrorState = ERROR_STATE();
		IF XACT_STATE() <> 0 AND @starttrancount = 0 
			ROLLBACK TRANSACTION
	   RAISERROR (@ErrorMessage, -- Message text.
				   @ErrorSeverity, -- Severity.
				   @ErrorState -- State.
				   );
	END CATCH
END
;
GO
;

CREATE PROCEDURE INSERT_CONSTRAINT_ATTACHMENT
       @p_art_id bigint,
       @p_cont_cons_id bigint
AS
BEGIN
       
       INSERT INTO CONTENT_CONSTRAINT_ATTACHMENT
           (CONT_CONS_ID, ART_ID)
     VALUES
           (@p_cont_cons_id, @p_art_id);
END
;
GO
;

CREATE PROCEDURE INSERT_CUBE_REGION
       @p_cont_cons_id bigint,
       @p_include bigint,
       @p_pk bigint OUT 
AS
BEGIN
       INSERT INTO CUBE_REGION
           (CONT_CONS_ID, INCLUDE)
     VALUES
           (@p_cont_cons_id, @p_include);
       set @p_pk = SCOPE_IDENTITY();

END
;
GO
;

CREATE PROCEDURE INSERT_CUBE_REGION_KEY_VALUE(
	@p_cube_region_id bigint,
	@p_member_id varchar(50),
	@p_component_type varchar(50),
	@p_include bigint,
	@p_pk bigint OUT )
AS
BEGIN
	INSERT INTO CUBE_REGION_KEY_VALUE
           (CUBE_REGION_ID, MEMBER_ID, COMPONENT_TYPE, INCLUDE)
     VALUES
           (@p_cube_region_id, @p_member_id, @p_component_type, @p_include);
	       set @p_pk = SCOPE_IDENTITY();
END
;
GO
;

CREATE PROCEDURE INSERT_CUBE_REGION_VALUE(
	@p_cube_region_key_value_id bigint,
	@p_member_value varchar(50),
	@p_include bigint)
AS
BEGIN
	INSERT INTO CUBE_REGION_VALUE
           (CUBE_REGION_KEY_VALUE_ID, MEMBER_VALUE, INCLUDE)
     VALUES
           (@p_cube_region_key_value_id, @p_member_value, @p_include);
END
;
GO
;

-- always last
update DB_VERSION SET VERSION = '3.3'
;
